#Darwish Electron Model.  Assumes a low field mobility has
#already been defined and $mun is the electron mobility.

#Model parameters
set DHB 1.51e7
set DHC 4.18e3
set DHtau 0.0119
set DHdelta 4.1e15
set DHA 2.18
set DHalpha 7.82e-21
set DHeta 0.123
set DHkappa 0.9

#surface acoustic phonon scattering
#set DHTpri [expr pow(($Temp/300.0),$DHkappa)]
set DHTpri "((T/300.0)^$DHkappa)"
set DHfoo "(($DHB*$DHTpri)/(trans(DevPsi)+1.0e-10))"
set DHfoo "($DHfoo+($DHC*(Donors+Acceptors+Elec)^$DHtau)/((trans(DevPsi)+1.0e-10)^([expr 1.0/3.0])))"
set DHmuac "($DHfoo*(1.0/$DHTpri))"

#surface roughness scattering
set DHgamma "(($DHA+(($DHalpha*(Elec+Hole))/((Donors+Acceptors+Elec)^($DHeta)+1.0e-15))))"
set DHmusr "($DHdelta/((trans(DevPsi)+1e-20)^($DHgamma)+1.0e-20))"

# Combine using Mathiesson's rule
set DHfoo "(($mup)*($DHmuac)*($DHmusr)/(($mup)*($DHmuac)+($DHmuac)*($DHmusr)+($DHmusr)*($mup)))"
term name=DHmob add eqn=$DHfoo
set $mup "DHmob"
