
proc Continuity { F Elec } {
	set mob [pdbGetDouble Niobium mob]

	return "ddt($Elec) + $mob * $Elec * grad($F)"
}
# example
# puts [Continuity F Elec]
# pdbSetString Niob1 F    Equation [Continuity F Elec]

proc ContinuityTunnel { F Conductivity } {
	set Atoms [pdbGetDouble Niobium Atoms]
	set q [pdbGetDouble FundamentalConstants q]
	#set mob [ expr $Conductivity/($Atoms*$q)  ]
	#puts [dict get $c mob]
	#puts $mob
	#puts $Conductivity
	#puts [dict get $c Conductivity]
	#puts [expr [dict get $c Conductivity]/($Atoms*$q)]
	#puts [expr $Conductivity/$q]
	#puts [expr [dict get $c mob] * $Atoms]
	#gets stdin

	#return "ddt(Elec) + 1e22*$Conductivity * grad($F)"
	#return "ddt(Elec) + [dict get $c Conductivity] * grad($F)"
	#return "ddt(Elec) + [dict get $c mob] * $Atoms * 5e-4 * grad($F)"
	return "$Conductivity/$q * grad($F)"
}

# Jc units are mA/um^2
proc ConstConductance { Jc } {
	set gap [pdbGetDouble DynamicConstants gap]
	# Convert Jc to G
	return [ expr $Jc*1e-3/2./$gap ]
}
# puts [ConstConductance 0.1]
# Returns a Continuity interface equation
# RegionA is the region of the equation
# RegionB is the region next to the equation

proc SimpTunnelInterface  { F RegionA RegionB Conductance Y Z } {
	set q [pdbGetDouble FundamentalConstants q]
	set gap [pdbGetDouble DynamicConstants gap]
	set CurRatio 0.1
	set Diff ($F\($RegionA)-$F\($RegionB))
	return "$F\($RegionA)-$Conductance/(1e-4*1e-4*$Z*$Y)/$q*((abs($Diff) > [expr 2*$gap]) ? $Diff : [expr $CurRatio*1e-3])"
} 
# puts [SimpTunnelInterface F Niob2 Niob1 [ConstConductance 100e-6] 1 1]
# pdbSet Niob1_Niob2 F Niob2 Equation [SimpTunnelInterface F Niob2 Niob1 [ConstConductance 100e-6] 1 1]
# pdbSet Niob1_Niob2 F Niob1 Equation [SimpTunnelInterface F Niob1 Niob2 [ConstConductance 100e-6] 1 1]


proc CarrierRelationship { DevPsi F } {
	set ni [pdbGetDouble Niobium Atoms]
	set Vt [pdbGetDouble DynamicConstants Vt]

	return "$ni*(($DevPsi-$F)/$Vt + 1)"
}

proc F12CarrierRelationship { DevPsi F } {
	set ni [pdbGetDouble Niobium Atoms]
	set Vt [pdbGetDouble DynamicConstants Vt]

	return "$ni*F12(($DevPsi-$F)/$Vt)"
}

proc Contact {Contact F DevPsi Elec} {
	#set Vt [dict get $c Vt]
	#set ni [dict get $c ni]
    pdbSet $Contact $F      Flux 1
    pdbSet $Contact $DevPsi Flux 1
    pdbSet $Contact $F      Fixed 1
    pdbSet $Contact $DevPsi Fixed 1
    pdbSet $Contact $F Flux.Scale 1.619e-19
    pdbSet $Contact $F Equation "$F-$Contact"
    pdbSet $Contact $DevPsi Equation "Doping - $Elec"
    #pdbSetString $Contact Equation "1.619e-19 * (Flux_Hole - Flux_Elec)"
}
#Contact VSS F DevPsi Elec
#Contact GND F DevPsi Elec

# Jc units are mA/um^2
# proc AvgBarrierThickness { G G0 t0 } {
# 	set alpha -1
# 	# Convert Jc to G
# 	return [ expr log10($G/$G0)/$alpha+$t0 ]
# }
# #puts [AvgBarrierThickness 500 100 0.9]
# proc AvgBarrierThickness { G G0 t0 } {
# 	set alpha -1
# 	# Convert Jc to G
# 	return [ expr log10($G/$G0)/$alpha+$t0 ]
# }
# puts [AvgBarrierThickness 500 100 0.9]

proc AvgBarrierThickness { G G0 t0 } {
	set lambda -0.069
	# Convert Jc to G
	return [ expr log10($G/$G0)*$lambda+$t0 ]
}
#puts [AvgBarrierThickness 500 100 0.9]


