# convert data of the format
# { x value material } 
proc ExtractPrint1dValues { data } {
	for { set i 1 } { $i < [llength $data]-1 } { incr i } {
		lappend List [lindex $data $i 0 1]
	}
	return $List
}

proc Max { data } {
	set max -1e100
	for { set i 0 } { $i < [llength $data] } { incr i } {
		if { [lindex $data $i] > $max } { 
			set max [lindex $data $i]
		}
	}
	return $max
}
proc Min { data } {
	set min 1e100
	for { set i 0 } { $i < [llength $data] } { incr i } {
		if { [lindex $data $i] < $min } { 
			set min [lindex $data $i]
		}
	}
	return $min
}
proc Sum { data } {
	set sum 0
	for { set i 0 } { $i < [llength $data] } { incr i } {
		set sum [ expr $sum+[lindex $data $i] ]
	}
	return [ expr $sum ]
}
proc Avg { data } {
	set sum [Sum $data]
	return [ expr $sum/([llength $data]) ]
}
proc SD { data } {
	set sum 0
	set avg [Avg $data]
	for { set i 0 } { $i < [llength $data] } { incr i } {
		set sum [ expr $sum+([lindex $data $i] - $avg)**2 ]
	}
	return [ expr sqrt($sum/([llength $data])) ]
}
proc Skew { data } {
	set sum 0
	set avg [Avg $data]
	set sd  [SD $data]
	for { set i 0 } { $i < [llength $data] } { incr i } {
		set sum [ expr $sum+([lindex $data $i] - $avg)**3 ]
	}
	return [ expr $sum/[llength $data]/($sd**3) ]
}
proc Kurt { data } {
	set sum 0
	set avg [Avg $data]
	set sd  [SD $data]
	for { set i 0 } { $i < [llength $data] } { incr i } {
		set sum [ expr $sum+([lindex $data $i] - $avg)**4 ]
	}
	return [ expr $sum/[llength $data]/($sd**4) ]
}
# puts "[Kurt  $dat ] >= [expr [Skew  $dat ]**2 + 1]"
# Kurtosis is bounded below by the skewness squared plus 1
proc ExcessKurt { data } {
	return [expr [Kurt  $data ] - 3]
}

