#Parameter values for Arsenic
set KEmumax 1414.0
set KEmumin 68.5
set KENref1 9.2e16
set KEalph1 0.711
set KEcD 0.21
set KENrefD 4.0e20
set KEcA 0.50
set KENrefA 7.2e20
set KEtheta_e 2.285
set KEtheta_h 2.247

#Klaussen's fit parameters
set KEme 1.0
set KEmh 1.258
set KEfcw 2.459
set KEfbh 3.828

# Lattice scattering
set KEmuL "($KEmumax*(300.0/T)^$KEtheta_e)"

# Impurity and Hole Scattering.
set KEmuiN [expr "($KEmumax*$KEmumax/($KEmumax-$KEmumin))"]
set KEmuiN "($KEmuiN*(T/300.0)^(3.0*$KEalph1-1.5))"
set KEmuiC [expr "($KEmumax*$KEmumin/($KEmumax-$KEmumin))"]
set KEmuiC "($KEmuiC*(300.0/T)^0.5)"
set KENsc "(Donors+Acceptors+Hole)"
set KEPBH "(1.36e20/Elec*$KEme*(T/300.0)^2.0)"
set KEfoo "(1.0+1.0/($KEcA+($KENrefA/$KENsc)^2.0))"
term name=KEZ add eqn=$KEfoo
set KEPCW "(3.97e13*((1.0/((KEZ)^3.0*$KENsc))*(T/300.0)^3.0)^(2.0/3.0))"
set KEfoo "(1.0/($KEfcw/($KEPCW)+$KEfbh/($KEPBH)))"
term name=KEP add eqn=$KEfoo

set KEs1 0.89233
set KEs2 0.41372
set KEs3 0.19778
set KEs4 0.28227
set KEs5 0.005978
set KEs6 1.80618
set KEs7 0.72169
set KEfoo "(1.0-$KEs1/($KEs2+((T/300.0/$KEme)^$KEs4)*(KEP))^$KEs3+$KEs5/((($KEme*300.0/T)^$KEs7)*KEP)^$KEs6)"
term name=KE_G add eqn=$KEfoo

set KEr1 0.7643
set KEr2 2.2999
set KEr3 6.5502
set KEr4 2.3670
set KEr5 -0.01552
set KEr6 0.678
set KEfoo "(($KEr1*KEP^$KEr6+$KEr2+$KEr3*$KEme/$KEmh)/(KEP^$KEr6+$KEr4+$KEr5*$KEme/$KEmh))"
term name=KE_F add eqn=$KEfoo

set KENsceff "(Donors+KE_G*Acceptors+Hole/KE_F)"

set KEfoo "($KEmuiN*$KENsc/$KENsceff*($KENref1/$KENsc)^$KEalph1+$KEmuiC*(Elec+Hole)/$KENsceff)"
term name=KEmuDAh add eqn=$KEfoo

# Combine using Mathiesson's rule
set KEfoo "($KEmuL*KEmuDAh/($KEmuL+KEmuDAh))"
term name=KEmob add eqn=$KEfoo
set mun "KEmob"
