namespace eval Germanium {

proc Nv args {
  set name [lindex [info level 0] 0]
  lappend usage "$name T="
  lappend usage {Temperature (T) is in Kelvin.}
  set returns {alagator string}
  set description {Temperature dependent hole density of states model.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set T [__GetValue $args T "Temperature parameter (T) in Kelvin required"]

  set q 1.602e-19
  set k 1.38066e-23
  set Vt ([expr {$k/$q}]*$T)
  set small 1.0e-10
  set pi [ expr acos(-1.0) ]
  set m0 9.10938356e-31 ;#kg
  set hbar 1.05457e-34 ;#J/s
  set mn [ expr 0.34 * $m0 ]
  puts [ expr 2.* ( 300 *  ( $mn*$k )/( 2.*$pi*$hbar**2. ) )**1.5 /100.**3. ] ;# 1/cm^3
  set Nv [ expr 2.* ( ( $mn*$k )/( 2.*$pi*$hbar**2. ) )**1.5 /100.**3. ] ;# 1/cm^3
  
  # need to find the source for this... I think it is an experimental value
  # set Nv [expr 2.8e19 * 300**-1.5] ;# 1/cm^3

  return (($T)^(1.5)*$Nv) ;# 1/cm^3
  
}

}



