namespace eval Germanium {

proc BandGap args {
  set name [lindex [info level 0] 0]
  lappend usage "$name T="
  lappend usage {Temperature (T) is in Kelvin.}
  set returns {alagator string}
  set description {Temperature dependent band gap model.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set T [__GetValue $args T "Temperature parameter (T) in Kelvin required"]
  
  # Temp dependent bandgap model
  set alpha 4.80e-4 ;# eV/K
  set beta 235.0 ;# K
  set Eg0 0.742  ;# eV
  return "($Eg0-$alpha*$T^2/($T+$beta))" ;# eV
  
}


}
