
proc GeProcs {{gen 0}} {
  global ProcsDir FLXSHOME
  set origProcs [info procs]
  if { [info exists ProcsDir] } {
    set FileDir $ProcsDir/Models/Germanium/
  } else {
    set FileDir $FLXSHOME/TclLib/Device/floods/Germanium/
  }
  uplevel 0 {source $FileDir/Mobility/constant.tcl}
  uplevel 0 {source $FileDir/Mobility/Masetti/model.tcl}
  
  uplevel 0 {source $FileDir/Strain/params.tcl}
  # if { !$gen } {
  #   Germanium::SetStrainParams
  # }
  # uplevel 0 {source $FileDir/Strain/HoleModels.tcl}
  # uplevel 0 {source $FileDir/Strain/ElecModels.tcl}
  
  uplevel 0 {source $FileDir/Bandstructure/Nc.tcl}
  uplevel 0 {source $FileDir/Bandstructure/Nv.tcl}
  uplevel 0 {source $FileDir/Bandstructure/bandgap.tcl}

  uplevel 0 {source $FileDir/Equations.tcl}
  
  if { !$gen } {
    puts [ccolor::replace "<cb>Loaded procedures: </>"]
    set procs [info procs]
    foreach x $procs {
      set unique 1
      foreach y $origProcs {
        if { $y == $x } { set unique 0 }
      }
      if { $unique } { puts [ccolor::replace "<g>\t$x</>"]  }
    }
  }
  
}


