
namespace eval Germanium {


proc Get3DElecDPTensor args {
  set name [lindex [info level 0] 0]
  lappend usage "$name Elecs=? Mobs=? miller=(001)<100>"
  lappend usage "Vector of electron populations of length three called Elecs"
  lappend usage "Tensor of mobilites with dimension 3x3. Where the row is the valley direction and the column is the current direction."
  lappend usage "Miller indicies (miller) are in (hkl)<uvw> format and defaults to 001 wafers with 100 channels."
  set returns "Tensor list containing the relative conductivity changes for holes"
  set description {Computes the normalized conductivity change for holes according to the linear piezoresistance model}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }
  set Elecs [__GetValue $args Elecs "$name Error: No electron population vector (Elecs) provided"]
  set Mobs [__GetValue $args Mobs "$name Error: No mobility tensor (Mobs) provided"]
  set miller [__GetValue $args miller]
  if {$miller == ""} { set miller (001)<100> }

  set TensorList ""
  # this is if we figure out we need a tensor elec
  # for { set i 0 } { $i < 3 } { incr i } {
  #   set TenListTmp ""
  #   # lappend TenListTmp [lindex [GetMobilityTensor [lindex [__getXmobs "0 0 0 0 0 0" $miller $Elecs Silicon ] $i ] ] 0]
  #   # lappend TenListTmp [lindex [GetMobilityTensor [lindex $Mobs  $i ] ] 0]
  #   # lappend TenListTmp [lindex [GetMobilityTensor [lindex $Elecs $i ] ] 0]
  #   lappend TenListTmp [lindex [GetMobilityTensor [lindex $Mobs $i ] ] 0]
  #   lappend TenListTmp [lindex [__RotateTensor [GetMobilityTensor [lindex $Elecs $i ] ] $miller] 0]
  #   set TenTmp [3DTensorDyadicMult $TenListTmp] 
  #   lappend TensorList "[lindex $TenTmp 0]"
  # }
  # Sticking to the simplier method for now
  for { set i 0 } { $i < 3 } { incr i } {
    set TenListTmp ""
    # lappend TenListTmp [lindex [GetMobilityTensor [lindex [__getXmobs "0 0 0 0 0 0" $miller $Elecs Silicon ] $i ] ] 0]
    lappend TenListTmp [lindex [GetMobilityTensor [lindex $Mobs $i ] ] 0]
    # only rotate carrier tensor, mobility tensor includes splitting
    lappend TenListTmp [lindex [__RotateTensor [GetCarrierTensor [lindex $Elecs $i ] ] $miller] 0]
    set TenTmp [3DTensorDyadicMult $TenListTmp]
    lappend TensorList "[lindex $TenTmp 0]"
  }

  return [3DTensorAdd $TensorList]

}


}

