
proc MetalWorkFunction args {
  set name [lindex [info level 0] 0]
  lappend usage "$name sym=?"
  lappend usage {Chemical symbol (sym)}
  set returns {Schnek band to band tunneling alagator string}
  set description {Very complicated band to band tunneling model that incorporates the effects of recombination on band to band tunneling.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set sym [__GetValue $args sym "$name Error: Chemical symbol (sym) is given"]
  switch $sym {
    Cu { return 4.48 } 
    Al { return 4.24 } 
    Nb { return 4.87 } 
    Pd { return 5.6 } 
    Ag { return 5.01 } 
    W  { return 5.25 } 
    default {
      puts "$name Error: Chemical symbol (sym), $sym, not found"
      exit
    }
  }
}

# puts [MetalWorkFunction sym= Ag]
# MetalWorkFunction
