namespace eval Silicon {

proc Slotboom args {
  set name [lindex [info level 0] 0]
  lappend usage "$name Donor=Donor Accept=Accept"
  lappend usage {Temperature (T) is in Kelvin.}
  lappend usage {The Donor concentration (Donor) is assumed to be the alagator field Donor.}
  lappend usage {The Acceptor concentration (Accept) is assumed to be the alagator field Accept.}
  set returns {alagator string}
  set description {Slotboom bandgap narrowing model.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set Donor [__GetValue $args Donor ]
  if {$Donor == ""} { set Donor Donor }
  set Accept [__GetValue $args Accept ]
  if {$Accept == ""} { set Accept Accept }
  
  #then depends on doping (NA and ND). This is the "Slotboom" model.
  set Ebgn 6.92e-3;# eV
  set Nref 1.3e17;# /cm3
  
  return "($Ebgn*(log(($Accept+$Donor)/$Nref)+sqrt((log(($Accept+$Donor)/$Nref))^2+0.5)))"
  
}

proc OldSlotboom args {
  set name [lindex [info level 0] 0]
  lappend usage "$name Donor=Donor Accept=Accept"
  lappend usage {Temperature (T) is in Kelvin.}
  lappend usage {The Donor concentration (Donor) is assumed to be the alagator field Donor.}
  lappend usage {The Acceptor concentration (Accept) is assumed to be the alagator field Accept.}
  set returns {alagator string}
  set description {Old Slotboom bandgap narrowing model.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set Donor [__GetValue $args Donor ]
  if {$Donor == ""} { set Donor Donor }
  set Accept [__GetValue $args Accept ]
  if {$Accept == ""} { set Accept Accept }
  
  # then depends on doping (NA and ND). This is the "old Slotboom" model.
  set Ebgn 9.0e-3;# eV
  set Nref 1.0e17;# /cm3
  
  return "($Ebgn*(log(($Accept+$Donor)/$Nref)+sqrt((log(($Accept+$Donor)/$Nref))^2+0.5)))"
  
}



}
