namespace eval Silicon {

proc ElecHallFactorTemp args {
  set name [lindex [info level 0] 0]
  lappend usage "$name T="
  lappend usage {Temperature (T) is in Kelvin.}
  set returns {alagator string}
  set description {Computes temperature dependence of Hall scattering factor.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }
  set T [__GetValue $args T "$name Error: No temperature (T) specified"]

  # return [ expr -1.05e-8 * $T * $T * $T + 7.92e-6 * $T * $T - 9.87e-4 * $T + 0.9513]
  return (-1.05e-8*$T*$T*$T+7.92e-6*$T*$T-9.87e-4*$T+0.9513)
}

}
