set __searchfile ""
set __searchdata ""
proc __build_search_data {} {
  global __searchfile
  if { [catch {file tempfile} __searchfile] == 1 } { return }
  rename puts puts_orig_search
  proc puts args {
    global __searchfile
    if { [llength $args ] == 1 } {
      puts_orig_search [set __searchfile] [lindex $args 0]
    }
  }
  global __searchdata
  set __searchdata ""
  foreach p [lsort [info procs]] {
    # skip api functions
    if { [ string first pdb $p ] > -1 || $p == "InitDefect" || $p == "InitCluster" || $p == "Smooth" || $p == "search" || ([string index $p 0] == "_" && [string index $p 1] == "_") } {
      continue
    }
    set pos [tell [set __searchfile]]
    if { ![catch {$p -help}] } {
      flush [set __searchfile]
      seek [set __searchfile] $pos
      lappend __searchdata [read [set __searchfile]]
    }
  }
  rename puts ""
  rename puts_orig_search puts
  close [set __searchfile]
}
__build_search_data
proc search args {
  set name [lindex [info level 0] 0]
  lappend usage "$name keyword keyword keyword ..."
  set returns "nothing"
  set description "Searches all help messages with keywords and prints matching messages. The -all flag is available to print all the messages that match, default is to just print the top 3."
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }
  if { [llength $args] == 0 } { return "" }
  # check for -all option
  set all [__Contains $args -all]
  set args [__Remove $args -all]
  # make search case insensitive
  set search_string [string tolower $args ]
  global __searchdata
  
  set results ""
  foreach d [set __searchdata] {
    set match 0
    foreach ss $search_string {
      if { [string first $ss [string tolower $d]] > -1 } {
        incr match
      }
    }
    if { $match } {
      lappend results "$match $d"
    }
  }
  if { $all } {
    puts "Found [llength $results] results"
  } else {
    puts "Found [llength $results] results, only top 3 are displayed (use -all to see all results)"
  }
  set i 1
  foreach r [lsort -decreasing $results] {
    puts "\n$r"
    if { !$all && [incr i] > 3 } { break }
  }
}

# search tensor
# search -all tensor
# search kanda electron








