proc GridExists {} {
  return [expr ![catch {sel z=1}]]
}
proc __GenGrid {1ddifnum state} {
  # if { [GridExists] } {
  # }
  options [set [set state]units]
  set [set state]bottom [set [set state]bottom_new]
  set [set state]top [set [set state]top_new]
  set bottom [set [set state]bottom]
  set top [set [set state]top]
  set spac [expr ($bottom - $top)/500.]
  line x loc=$top    spac=$spac tag=Top
  line x loc=$bottom spac=$spac tag=Bottom
  region silicon xlo=Top xhi=Bottom 
  init
  destroy .1ddif[set 1ddifnum]grid
  # set 1ddifnum $tkstate::1ddifnum
  set toplvl .1ddif[set 1ddifnum]
  destroy $toplvl
  1ddifWidget [set 1ddifnum]
}
proc __EditGrid {1ddifnum state} {
  set toplvl .1ddif[set 1ddifnum]grid
  toplevel $toplvl
  frame $toplvl.win 
  pack $toplvl.win 
  pack [label $toplvl.win.title -text "Grid"] 
  # Grid section
  pack [frame $toplvl.win.units]
  grid [radiobutton $toplvl.win.units.um -text "um" -variable [set state]units -value "um"  -command "set [set state]units um"] -row 1 -column 2
  grid [radiobutton $toplvl.win.units.nm -text "nm" -variable [set state]units -value "nm"  -command "set [set state]units nm"] -row 1 -column 3

  set [set state]bottom_new [set [set state]bottom]
  set [set state]top_new [set [set state]top]
  pack [frame $toplvl.win.grid -padx 20 -pady 10 ] -side right
  pack [frame $toplvl.win.grid.top  ]
  pack [label $toplvl.win.grid.top.title -width 16 -anchor w -text "Top"] -side left 
  pack [entry $toplvl.win.grid.top.value -width 10 -textvariable [set state]top_new] -side right
  pack [frame $toplvl.win.grid.bottom  ]
  pack [label $toplvl.win.grid.bottom.title -width 16 -anchor w -text "Bottom"] -side left 
  pack [entry $toplvl.win.grid.bottom.value -width 10 -textvariable [set state]bottom_new] -side right
  pack [button $toplvl.win.grid.button -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 20 -text "Generate Grid" -command "__GenGrid [set 1ddifnum] $state"] -side left

}

proc __PlotMeas {state} {
  pdbSet plot scale 0.5
  pdbSet plot fontScale 1.4
  window pngcairo file= meas.png width= 500 height= 500
  foreach d [set [set state]data] {
    lassign $d measurment fileName floor offset log
    if { $fileName == "" && ![file exists $fileName] } { continue }
    set floor 1e14
    sel z= $floor name= $measurment
    if { $log } {
      profile infile= $fileName  name= $measurment offset= $offset
      sel z= (($measurment>$floor)?($measurment):($floor))
    } else {
      profile infile= $fileName  name= $measurment offset= $offset linear
      sel z= log10(($measurment>$floor)?($measurment):($floor))
    }
    plot1d name= $measurment ylab= "Concentration log#d10#u(cm#u-3#d)" title= ""
  }
  window null
  image create bitmap [set state]measpng -background "white"
  image create photo [set state]measpng -file meas.png
}
proc __AddMeas {toplvl state measurment locvar} {
  set fil [tk_getOpenFile -title "Open Meas profile data"]
  set newdata [set [set state]data] 
  for { set i 0 } { $i < [llength $newdata] } { incr i } {
    lassign [lindex $newdata $i] measurment2 fileName
    if { $measurment == $measurment2 } { break }
  }
  lset newdata $i 1 $fil
  set [set state]data $newdata
  set $locvar $fil
}

proc __DelMeas {toplvl state measurment} {
  set data [set [set state]data] 
  for { set i 0 } { $i < [llength $data] } { incr i } {
    lassign [lindex $data $i] measurment2 fileName
    if { $measurment == $measurment2 } { break }
  }
  set [set state]data [lreplace $data $i $i]
  __PlotMeas $state
  destroy $toplvl
  set 1ddifnum [set [set state]1ddifnum]
  set toplvl .1ddif[set 1ddifnum]
  destroy $toplvl
  1ddifWidget [set 1ddifnum]
}

proc __SaveAndExitMeas {toplvl state i} {
  if { [set [set state]$toplvl\measurment] == "" } { return } 
  set newdata [set [set state]data] 
  lset newdata $i 0 [set $state[set toplvl]measurment]
  lset newdata $i 1 [set $state[set toplvl]fileName]
  lset newdata $i 2 [set $state[set toplvl]floor]
  lset newdata $i 3 [set $state[set toplvl]offset]
  lset newdata $i 4 [set $state[set toplvl]log]
  set [set state]data $newdata
  destroy $toplvl
  # __PlotMeas $state
  set 1ddifnum [set [set state]1ddifnum]
  set toplvl .1ddif[set 1ddifnum]
  destroy $toplvl
  1ddifWidget [set 1ddifnum]
}
proc __AddEditMeasurment {toplvl state i} {
  if { $i < 0 } {
    lappend [set state]data {Placeholder {} 1e14 0 0 0}
    set i [expr [llength [set [set state]data]]-1]
  }
    set toplvl [set toplvl]addedit$i
    toplevel $toplvl
    pack [frame $toplvl.win]
  pack [frame $toplvl.win.data -padx 20 -pady 10 ] -side right
  pack [label $toplvl.win.data.title -text "Measurment"] 
  pack [frame $toplvl.win.data.label  ]
  pack [label $toplvl.win.data.label.title -width 15 -anchor w -text "Measurment Name"] -side left 
  pack [label $toplvl.win.data.label.value0 -width 20 -anchor e -text "File Name"] -side left
  pack [label $toplvl.win.data.label.value1 -width 5 -anchor e -text "Floor"] -side left 
  pack [label $toplvl.win.data.label.value2 -width 5 -anchor e -text "Offset"] -side left
  pack [label $toplvl.win.data.label.value3 -width 5 -anchor e -text "Log"] -side left

    lassign [lindex [set [set state]data] $i] measurment fileName floor offset log
    pack [frame $toplvl.win.data.d$i ]
    set $state[set toplvl]measurment $measurment
    pack [entry $toplvl.win.data.d$i.title -width 15 -textvariable $state[set toplvl]measurment] -side left 

    pack [frame $toplvl.win.data.d$i.fil ] -side left
    set $state[set toplvl]fileName $fileName
    pack [label $toplvl.win.data.d$i.fil.value0 -width 20 -font {Helvetica 8 bold} -anchor e -textvariable $state[set toplvl]fileName]
    pack [button $toplvl.win.data.d$i.fil.button -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 10 -text "Choose File" -command "__AddMeas $toplvl $state [set $state[set toplvl]measurment] $state[set toplvl]fileName"]

    set $state[set toplvl]floor $floor
    pack [entry $toplvl.win.data.d$i.value1 -width 5 -textvariable $state[set toplvl]floor] -side left
    set $state[set toplvl]offset $offset
    pack [entry $toplvl.win.data.d$i.value2 -width 5 -textvariable $state[set toplvl]offset] -side left 
    set $state[set toplvl]log $log
    pack [checkbutton $toplvl.win.data.d$i.value3 -width 0 -variable $state[set toplvl]log ] -side left

   pack [button $toplvl.win.data.delbutton -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 30 -text "Remove Meas Data" -command "__DelMeas $toplvl $state $measurment"]
   pack [button $toplvl.win.data.savebutton -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 30 -text "Save and Exit" -command "__SaveAndExitMeas $toplvl $state $i"]
}

proc __RunDiffusion {toplvl state} {
  # foreach d [set [set state]data] {
  #   lassign $d measurment fileName floor offset log
  # }
  set diffspec  [set [set state]diffspec]
  set diffconst [set [set state]diffconst]

  set initial [lindex [set [set state]data] 0 0]
  sel z= $initial name= $diffspec

  solution add name= $diffspec solve !negative
  pdbSet Si $diffspec Equation "ddt($diffspec) - ($diffconst)*grad($diffspec)"
  window pngcairo file= sim.png width= 500 height= 500
  set [set state]progress 0
  # toplevel [set toplvl]progress
  # pack [frame [set toplvl]progress.win]
  # pack [label [set toplvl]progress.win.title -width 20 -font {Helvetica 20 bold} -text "Simulating Step"]
  # pack [label $toplvl\progress.win.lab -width 20 -font {Helvetica 20 bold} -textvariable [set state]progress]
  # pack [ttk::progressbar $toplvl\progress -orient horizontal -length 200 -mode determinate -variable $state\progress -maximum [llength [set [set state]sims]]]
  # pack [ttk::progressbar $toplvl\progress -orient horizontal -length 200 -mode determinate -variable $state\progress -maximum [llength [set [set state]sims]]]
  set time_acum 0
  foreach s [set [set state]sims] {
    lassign $s TIME plot
    diffuse time= $TIME
    set time_acum [expr $time_acum+$TIME]
    sel z= log10($diffspec) name= $time_acum\s
    if { $plot } {
      plot1d name= $time_acum\s ylab= "Concentration log#d10#u(cm#u-3#d)" title= ""
    }
    incr [set state]progress 
  }
  window null
  image create bitmap [set state]simpng -background "white"
  image create photo [set state]simpng -file sim.png
  # destroy [set toplvl]progress
}
proc __DelError {toplvl state measurment step} {
  set err [set [set state]err] 
  for { set i 0 } { $i < [llength $err] } { incr i } {
    lassign [lindex $err $i] measurment2 step2
    if { $measurment == $measurment2 && $step == $step2 } { break }
  }
  set [set state]err [lreplace $err $i $i]
  destroy $toplvl
  set 1ddifnum [set [set state]1ddifnum]
  set toplvl .1ddif[set 1ddifnum]
  destroy $toplvl
  1ddifWidget [set 1ddifnum]
}
proc __SaveAndExitError {toplvl state i} {
  if { [set $state[set toplvl]measurment] == "" } { return } 
  set newerr [set [set state]err] 
  lset newerr $i 0 [set $state[set toplvl]measurment]
  lset newerr $i 1 [set $state[set toplvl]step]
  set [set state]err $newerr
  destroy $toplvl
  set 1ddifnum [set [set state]1ddifnum]
  set toplvl .1ddif[set 1ddifnum]
  destroy $toplvl
  1ddifWidget [set 1ddifnum]
}
proc __AddEditError {toplvl state i} {
    if { $i < 0 } {
      lappend [set state]err {AsGrown 1}
      set i [expr [llength [set [set state]err]]-1]
    }
    set choices ""
    foreach d [set [set state]data] {
       lassign $d m
       lappend choices $m
    }
    set steps ""
    set j 1
    foreach d [set [set state]sims] {lappend steps $j; incr j;}
    
    set toplvl [set toplvl]addediterr$i
    toplevel $toplvl
    pack [frame $toplvl.win]
    pack [frame $toplvl.win.err -padx 20 -pady 10 ] -side right
    pack [label $toplvl.win.err.title -text "Measurment"] 
    pack [frame $toplvl.win.err.label  ]
    # pack [label $toplvl.win.err.label.title -width 15 -anchor w -text "Measurment Name"] -side left 
    set len [expr [llength $choices]>[llength $steps]?[llength $choices]:[llength $steps]]
    pack [listbox $toplvl.win.err.label.measurment -height $len ] -side left 
    bind $toplvl.win.err.label.measurment {<<ListboxSelect>>}  "set $state[set toplvl]measurment \[$toplvl.win.err.label.measurment get active\]"
    $toplvl.win.err.label.measurment insert 0 {*}$choices
    pack [listbox $toplvl.win.err.label.step -height $len ] -side left 
    bind $toplvl.win.err.label.step {<<ListboxSelect>>}  "set $state[set toplvl]step \[$toplvl.win.err.label.step get active\]"
    $toplvl.win.err.label.step insert 0 {*}$steps

    lassign [lindex [set [set state]err] $i] measurment step
    pack [frame $toplvl.win.err.d$i]
    set $state[set toplvl]measurment $measurment
    pack [label $toplvl.win.err.d$i.m -width 15 -textvariable $state[set toplvl]measurment] -side left 
    set $state[set toplvl]step $step
    pack [label $toplvl.win.err.d$i.s -width 15 -textvariable $state[set toplvl]step] -side left 

    pack [button $toplvl.win.err.delbutton -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 30 -text "Remove Error" -command "__DelError $toplvl $state $measurment $step"]
    pack [button $toplvl.win.err.savebutton -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 30 -text "Save and Exit" -command "__SaveAndExitError $toplvl $state $i"]
}


proc __RunOptimization {toplvl state} {
    # proc ::__1DDiffErrorFxn { params } "
    #   set state $state
    #   return \[expr (\[lindex \$params 0\]-1e-17)**2\]
    # "
    set diffspec  [set [set state]diffspec]
    set initial [lindex [set [set state]data] 0 0]
    solution add name= $diffspec solve !negative
    set [set state]progress 0
    options quiet
    proc ::__1DDiffErrorFxn { params } "
      sel z= $initial name= $diffspec
      set diffconst \[lindex \$params 0\]
      pdbSet Si $diffspec Equation \"ddt($diffspec) - (\$diffconst)*grad($diffspec)\"
      set L2 0
      set i 1
      foreach s \[set [set state]sims\] {
        lassign \$s TIME plot
        diffuse time= \$TIME
        foreach e \[set [set state]err\] {
          lassign \$e measurment step 
          foreach d \[set [set state]data\] {
            lassign \$d measurment2 fileName floor offset log
            if { \$measurment == \$measurment2 && \$step == \$i } {
              sel z=(log10($diffspec)-log10(\$measurment))^2*(\$measurment>\$floor)
              set L2 \[expr \$L2 + \[lindex \[layers\] 1 2\] * 1e9\]
            }
          }
        }
        incr i
      }
      return \$L2
    "
    set Dinit [set [set state]diffconst0]
    set opt_params [optimize errorFxn= __1DDiffErrorFxn initial_step= [expr $Dinit/100.] max_iterations= 10 rel_error= 1e-3 params= $Dinit names= D damp= [expr $Dinit/10.] h= [expr $Dinit*1e-4] ]
    set [set state]diffconstopt [format "%0.4e" $opt_params]
}

proc RenderDiffusion {toplvl state} {
  if { [GridExists] } { 
    pack [frame $toplvl.win.diff]
    set [set state]diffspec Phosphorus
    pack [frame $toplvl.win.diff.diffspec -padx 20 -pady 5 ]
    pack [label $toplvl.win.diff.diffspec.title -width 16 -anchor w -text "Diffusion Species"] -side left 
    pack [entry $toplvl.win.diff.diffspec.value -width 10 -textvariable [set state]diffspec] -side right
    pack [frame $toplvl.win.diff.diffconst -padx 20 -pady 5 ]
    pack [label $toplvl.win.diff.diffconst.title -width 16 -anchor w -text "Diffusion Constant"] -side left 
    pack [entry $toplvl.win.diff.diffconst.value -width 10 -textvariable [set state]diffconst] -side right
    pack [frame $toplvl.win.diff.diff -padx 20 -pady 0 ]
    pack [label $toplvl.win.diff.diff.title -width 20 -anchor w -text "Diffusion Simulations"]
    pack [label $toplvl.win.diff.diff.step -width 16 -anchor w -text "Step"] -side left 
    pack [label $toplvl.win.diff.diff.time -width 16 -anchor w -text "Time (s)"] -side left 
    pack [label $toplvl.win.diff.diff.plot -width 16 -anchor w -text "Plot"] -side left 
    pack [label $toplvl.win.diff.diff.blank -width 16 -anchor w -text ""] -side left 
    
    set len [llength [set [set state]sims]]
    set recompute "for {set i 1} { \$i <= $len } { incr i } { 
      lset [set state]sims \[expr \$i-1\] 0 \[set [set state]simtime\$i\]; 
      lset [set state]sims \[expr \$i-1\] 1 \[set [set state]simplot\$i\]; 
    };"
    set rerender "destroy $toplvl.win.diff; RenderDiffusion $toplvl $state;"
    set i 1
    foreach s [set [set state]sims] {
      lassign $s TIME plot
      set [set state]simtime$i $TIME
      set [set state]simplot$i $plot
      pack [frame $toplvl.win.diff.diff$i  -padx 0 -pady 0 ]
      pack [label $toplvl.win.diff.diff$i.step -width 16 -anchor w -text $i] -side left 
      pack [entry $toplvl.win.diff.diff$i.time -width 16 -textvariable [set state]simtime$i ] -side left 
      pack [checkbutton $toplvl.win.diff.diff$i.plot -width 0 -variable [set state]simplot$i ] -side left
  
      set command "$recompute set [set state]sims \[ lreplace \[set [set state]sims\] [expr $i-1] [expr $i-1] \];  $rerender"
      pack [button $toplvl.win.diff.diff$i.remove  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 10 -text "Remove" -command $command] -side left
      incr i
    }
    pack [button $toplvl.win.diff.add  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 40 -text "Add Diffusion Simulation" -command "$recompute lappend [set state]sims {1 1}; $rerender"]
    pack [button $toplvl.win.diff.run  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 40 -text "Run Diffusion Simulation" -command "$recompute; __RunDiffusion $toplvl [set state]"]
  
    # optimization
    pack [frame $toplvl.win.diff.opt -padx 0 -pady 10 ]
    pack [label $toplvl.win.diff.opt.title -width 25 -anchor w -text "Diffusion Optimization"]
    pack [frame $toplvl.win.diff.optconst -padx 0 -pady 0 ]
    pack [frame $toplvl.win.diff.optconst.init -padx 0 -pady 0 ] -side left
    pack [label $toplvl.win.diff.optconst.init.title -width 15 -text "Initial Diff Const"]
    pack [entry $toplvl.win.diff.optconst.init.value -width 15 -textvariable [set state]diffconst0 ]
    pack [frame $toplvl.win.diff.optconst.arrow -padx 0 -pady 0 ] -side left
    pack [label $toplvl.win.diff.optconst.arrow.title -width 15 -text "->"]
    pack [frame $toplvl.win.diff.optconst.final -padx 0 -pady 0 ] -side left
    pack [label $toplvl.win.diff.optconst.final.title -width 15 -text "Final Diff Const"]
    pack [label $toplvl.win.diff.optconst.final.value -width 15 -textvariable [set state]diffconstopt ]
    pack [frame $toplvl.win.diff.error -padx 0 -pady 10 ]
    pack [label $toplvl.win.diff.error.title -font {Helvetica 15} -text "Error"]
    pack [frame $toplvl.win.diff.error.table -padx 0 -pady 0 ]
    pack [label $toplvl.win.diff.error.table.measurment -font {Helvetica 12} -width 25 -text "Measurment"] -side left
    pack [label $toplvl.win.diff.error.table.step -font {Helvetica 12} -width 25 -text "Sim Step"] -side left
    set i 0
    foreach e [set [set state]err] {
      lassign $e m s
      pack [frame $toplvl.win.diff.error.table$i -padx 0 -pady 0 ]
      pack [label $toplvl.win.diff.error.table$i.measurment -font {Helvetica 12} -width 25 -text $m] -side left
      pack [label $toplvl.win.diff.error.table$i.step     -font {Helvetica 12} -width 25 -text $s] -side left
      pack [button $toplvl.win.diff.error.table$i.button  -font {Helvetica 10 bold} -height 0 -width 5 -text "Edit" -command "__AddEditError $toplvl $state $i"] -side left
      incr i
    }
    pack [button $toplvl.win.diff.error.button  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 20 -text "Add Error" -command "__AddEditError $toplvl $state -1"]
    pack [button $toplvl.win.diff.error.run  -padx 0 -pady 5 -font {Helvetica 15 bold} -height 0 -width 20 -text "Run Optimization" -command "__RunOptimization $toplvl $state"]
  }
}

proc RenderData {toplvl state} {
  if { ![GridExists] } { return }
  pack [frame $toplvl.win.init.data -padx 20 -pady 10 ]
  pack [label $toplvl.win.init.data.title -text "Measurment"] 
  pack [frame $toplvl.win.init.data.label  ]
  pack [label $toplvl.win.init.data.label.title -width 16 -anchor w -text "Measurment Name"] -side left 
  pack [label $toplvl.win.init.data.label.value0 -width 20 -anchor e -text "File Name"] -side left
  pack [label $toplvl.win.init.data.label.value1 -width 5 -anchor e -text "Floor"] -side left 
  pack [label $toplvl.win.init.data.label.value2 -width 5 -anchor e -text "Offset"] -side left
  pack [label $toplvl.win.init.data.label.value3 -width 5 -anchor e -text "Log"] -side left
  pack [label $toplvl.win.init.data.label.button -width 5 -anchor e -text "Edit"] -side left
  set i 0
  foreach d [set [set state]data] {
    lassign $d measurment fileName floor offset log
    pack [frame $toplvl.win.init.data.d$i ]
    pack [label $toplvl.win.init.data.d$i.title -width 16 -anchor w -text $measurment] -side left 
    # if { $fileName == "" } {
    #   pack [button $toplvl.win.init.data.d$i.button -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 10 -text "Add File" -command "__AddMeas $toplvl $state $measurment"] -side left
    # } else {
      pack [label $toplvl.win.init.data.d$i.value0 -width 20 -font {Helvetica 10 bold} -anchor e -text $fileName] -side left
    # }
    pack [label $toplvl.win.init.data.d$i.value1 -width 5 -anchor e -text $floor] -side left
    pack [label $toplvl.win.init.data.d$i.value2 -width 5 -anchor e -text $offset] -side left
    if { $log } {
      pack [label $toplvl.win.init.data.d$i.value3 -width 5 -anchor e -text Yes] -side left
    } else {
      pack [label $toplvl.win.init.data.d$i.value3 -width 5 -anchor e -text No] -side left 
    }
    pack [button $toplvl.win.init.data.d$i.button  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 5 -text "Edit" -command "__AddEditMeasurment $toplvl $state $i"] -side left
    incr i
  }
  pack [button $toplvl.win.init.data.button  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 20 -text "Add Measurment" -command "__AddEditMeasurment $toplvl $state -1"] -side left
}

proc 1ddifWidget {{1ddifnum -1}} {
  # set fil [tk_getOpenFile -filetypes {{{1D Diffusion Project} {.f1d}}} -title "Open or Create a New Project"]
  if { [set 1ddifnum] < 0 } {
    if { ! [info exists tkstate::1ddifnum] } {
      set tkstate::1ddifnum 0
    } else {
      set tkstate::1ddifnum [expr $tkstate::1ddifnum+1]
    }
    set 1ddifnum $tkstate::1ddifnum
    set toplvl .1ddif[set 1ddifnum]
    set state tkstate::[string map {. _} $toplvl]
    set [set state]1ddifnum [set 1ddifnum]
    set [set state]data ""
    # Initial Grid variables
    set [set state]units um 
    set [set state]bottom 0
    set [set state]top 0
    # initial data value
    set [set state]data {{AsGrown {} 1e14 0 0 0}}
    set [set state]sims ""
    set [set state]err  ""
    # initial diff constants
    set [set state]diffconst 3e-17
    set [set state]diffconst0 [set [set state]diffconst]
    set [set state]diffconstopt NA

  }

  set width 500
  set height 500

  set toplvl .1ddif[set 1ddifnum]
  toplevel $toplvl -width 1000 -height 500
  set state tkstate::[string map {. _} $toplvl]
  pack [frame $toplvl.win]
  # enforce the units
  options [set [set state]units]
  math diffuse dim=1 umf none col scale
  
  # data plot section
  if { [GridExists] } { 
    pack [frame $toplvl.win.plots] -side left
    pack [label $toplvl.win.plots.meastitle -text "Measurment Data"] 
    pack [canvas $toplvl.win.plots.meas -width $width -height 375 -background white]
    __PlotMeas $state
    $toplvl.win.plots.meas create image 0 -75 -anchor nw -image [set state]measpng
    pack [label $toplvl.win.plots.simtitle -text "Simulation Data"] 
    pack [canvas $toplvl.win.plots.sim -width $width -height 375 -background white]
    window pngcairo file= sim.png width= 500 height= 500
    window null
    image create photo [set state]simpng -file sim.png
    $toplvl.win.plots.sim create image 0 -75 -anchor nw -image [set state]simpng
  }
  # Grid section
  pack [frame $toplvl.win.init]
  pack [frame $toplvl.win.init.grid -padx 20 -pady 10 ]
  pack [label $toplvl.win.init.grid.title -text "Grid"] 
  pack [frame $toplvl.win.init.grid.top  ]
  pack [label $toplvl.win.init.grid.top.title -width 16 -anchor w -text "Top"] -side left 
  pack [frame $toplvl.win.init.grid.top.units  ]
  pack [label $toplvl.win.init.grid.top.units.units -textvariable [set state]units] -side right
  pack [label $toplvl.win.init.grid.top.units.value -textvariable [set state]top] -side right
  pack [frame $toplvl.win.init.grid.bottom  ]
  pack [label $toplvl.win.init.grid.bottom.title -width 16 -anchor w -text "Bottom"] -side left 
  pack [frame $toplvl.win.init.grid.bottom.units  ]
  pack [label $toplvl.win.init.grid.bottom.units.units -textvariable [set state]units] -side right
  pack [label $toplvl.win.init.grid.bottom.units.value -textvariable [set state]bottom] -side right
  pack [button $toplvl.win.init.grid.button  -padx 0 -pady 0 -font {Helvetica 10 bold} -height 0 -width 20 -text "Edit Grid" -command "__EditGrid [set 1ddifnum] $state"] -side left

  RenderData $toplvl $state
 
  # diffusion section
  RenderDiffusion $toplvl $state


  # $toplvl.win.canvas create text [expr $width*0.5] [expr $height*0.5] 
  
  # top menu
  menu $toplvl.menubar
  $toplvl configure -menu $toplvl.menubar
  $toplvl.menubar add cascade -menu $toplvl.menubar.file -label File
  menu $toplvl.menubar.file -tearoff 0
  set command {
    after idle ::getOpenFileHelper
    set fil [tk_getOpenFile -filetypes {{{Flooxs 1D Diffusion} {.f1d}}} -title "Open Existing 1D Diffusion Project"]
  }
  set command "$command; 
    if { \$fil != {} } { 
      exec tar xzf \$fil struct state
      destroy $toplvl
      struct infile= struct
      set ifil \[open state r\]
      set newstate \[split \[read \$ifil\] \"\n\"\]
      close \$ifil
      set [set state]data   \[lindex \$newstate 0\]
      set [set state]units  \[lindex \$newstate 1\] 
      set [set state]bottom \[lindex \$newstate 2\] 
      set [set state]top    \[lindex \$newstate 3\] 
      set [set state]sims    \[lindex \$newstate 4\] 
      set [set state]err    \[lindex \$newstate 5\] 
      set [set state]diffconst \[lindex \$newstate 6\]
      set [set state]diffconst0 \[lindex \$newstate 7\]
      set [set state]diffconstopt \[lindex \$newstate 8\]
      1ddifWidget [set 1ddifnum]
      file delete state struct
    }
  "
  $toplvl.menubar.file add command -label {Open Project} -command $command
  # initial data value
  if {[ GridExists ]} {
    set command {
      after idle ::getOpenFileHelper
      set fil [tk_getSaveFile -filetypes {{{Flooxs 1D Diffusion} {.f1d}}} -title "Save 1D Diffusion Project"]
      puts $fil
      puts [file tail $fil]
    }
    set command "$command; 
     if { \$fil != {} } { 
       set ofil \[open state w+\]
       puts \$ofil \[set [set state]data\]
       puts \$ofil \[set [set state]units\] 
       puts \$ofil $[set state]bottom
       puts \$ofil $[set state]top
       puts \$ofil \[set [set state]sims\]
       puts \$ofil \[set [set state]err\]
       puts \$ofil \[set [set state]diffconst\]
       puts \$ofil \[set [set state]diffconst0\]
       puts \$ofil \[set [set state]diffconstopt\]
       close \$ofil
       struct outfile= struct
       set dir /tmp/[clock seconds]
       file mkdir \$dir/out
       foreach d \[set [set state]data\] {
         lassign \$d measurment fileName
         if { \$fileName == {} } { continue }
         file copy \$fileName \$dir/out
       }
       exec tar cvzf \$fil state struct -C \$dir out
       file delete -force state struct \$dir
     }
    "
    $toplvl.menubar.file add command -label {Save Project} -command $command

    set script_data "options [set [set state]units]\nset top [set [set state]top]\nset bottom [set [set state]bottom]\nset data [set [set state]data]"
#     set script {
# ########### Build the Grid #########
# set spac [expr ($bottom - $top)/500.]
# line x loc=$top    spac=$spac tag=Top
# line x loc=$bottom spac=$spac tag=Bottom
# region silicon xlo=Top xhi=Bottom 
# init
# foreach d \[set [set state]data\] {
#   lassign \$d measurment fileName
# }
#     }
    set script "
struct infile= ejected.str
set diffspec  [set [set state]diffspec]
set diffconst [set [set state]diffconst]

sel z= [lindex [set [set state]data] 0 0] name= \$diffspec

solution add name= \$diffspec solve !negative
pdbSet Si \$diffspec Equation \"ddt(\$diffspec) - (\$diffconst)*grad(\$diffspec)\"
window width= 500 height= 500
    "
set time_acum 0
    foreach s [set [set state]sims] {
      lassign $s TIME plot
      set script "$script
diffuse time= $TIME
set time_acum [expr $time_acum+$TIME]
sel z= log10(\$diffspec) name= $time_acum\s
if { $plot } {
  plot1d name= $time_acum\s ylab= \"Concentration log#d10#u(cm#u-3#d)\" title= \"\"
}
"
    }
    set script "$script_data\n$script"
    set command "
       after idle ::getOpenFileHelper
       set fil \[tk_getSaveFile -title \"Eject 1D Diffusion Project\"\]
       puts \$fil
       set ofil \[open \$fil.tcl w+\]
       puts \$ofil  \[string map \"ejected.str \[file tail \$fil\].str\" {$script}\]
       close \$ofil
       struct outfile= \$fil.str
 "
    $toplvl.menubar.file add command -label {Eject To Script} -command $command
  }
  
}
