#*************************************************************************
#*									 *
#*     Copyright c 2002 The board of regents of the University of 	 *
#*                      Florida.  All rights reserved.			 *
#*     This subroutine may not be used outside of the FLOO* computer	 *
#*     programs without the prior written consent of the University of 	 *
#*     Florida.								 *
#*									 *
#*************************************************************************/


proc DimensionChangeMenu {} {
    set curDimension [flps_grid qual dim]
    set post .menubar.post

    if { $curDimension == 1 } {
	$post entryconfigure "Plot 1D" -state normal 
	$post entryconfigure "Plot Materials" -state disable 
	$post entryconfigure "Plot Grid" -state disable 
	$post entryconfigure "Contour" -state disable 
    } else {
	$post entryconfigure "Plot 1D" -state normal 
	$post entryconfigure "Plot Materials" -state normal 
	$post entryconfigure "Plot Grid" -state normal 
	$post entryconfigure "Contour" -state normal 
    }
}

proc UpdateSelectMembers {} {
    global Select 
    set sel .menubar.sel
    catch "$sel delete 0 end"

    $sel add command -label "Full Select" -command {
	set locExpr [SelDialog]
	global Select ParamRetcode
	if { $ParamRetcode } { set Select "$locExpr" }
    }
    $sel add separator
    set dim [flps_grid qual dim]
    if { $dim != 0 } {
	if { $dim >= 1 } {$sel add radiobutton -label "x" -variable Select }
	if { $dim >= 2 } {$sel add radiobutton -label "y" -variable Select }
	if { $dim >= 3 } {$sel add radiobutton -label "z" -variable Select }
	$sel add separator

	foreach var [sel list] {
	    $sel add radiobutton -label "$var" -variable Select 
	}
    }
}

menu .menubar

#the file menu section
.menubar add cascade -menu .menubar.file -label File
BuildFileMenu .menubar.file

#add a display for the current file
# frame .filedr -bd 2
# pack .filedr -side top -fill x -anchor w
# label .filedr.l1 -text "Current File: "
# label .filedr.l2 -textvariable curFile
# pack .filedr.l1 .filedr.l2 -side left -fill x -anchor w

#the recipes section
#.menubar add cascade -menu .menubar.recipes -label Recipe

#the process steps section
# .menubar add cascade -menu .menubar.steps -label Steps
#     set step .menubar.steps
#     menu $step -tearoff 0
# 
#     #full blown etch and deposit commands
#     $step add command -label "Full Deposit" -command {
# 	deposit -gui
#     }
#     $step add command -label "Full Etch" -command {
# 	etch -gui
#     }
#     $step add separator
# 
#     #short cut deposit, etch, and strip commands
#     $step add command -label "Iso Deposit" -command {
# 	DepDialog
#     }
#     $step add command -label "Aniso Etch" -command {
# 	EtchDialog
#     }
#     set strip $step.strip
#     $step add cascade -menu $strip -label "Strip" 
# 	menu $strip -tearoff 0
# 	$strip configure -postcommand {
# 	    set strip .menubar.steps.strip
# 	    catch "$strip delete 0 end"
# 	    foreach mat [mater bulk] {
# 		$strip add command -label $mat -command " strip $mat "
# 	    }
# 	}
#     $step add separator
# 
#     #doping commands
#     $step add command -label "Implant" -command {
# 	implant -gui
#     }
#     $step add command -label "Furnace Anneal" -command {
# 	furnace -gui
#     }
#     $step add command -label "RTA" -command {
# 	rta -gui
#     }

#selection menu
set Select Custom

# .menubar add cascade -menu .menubar.sel -label Select 
#     set sel .menubar.sel
#     menu $sel -tearoff 0 
#     $sel configure -postcommand UpdateSelectMembers

# #the post processing section
# .menubar add cascade -menu .menubar.post -label Post 
# BuildPostMenu .menubar.post

# #select model complexity
# .menubar add cascade -menu .menubar.models -label Models

. configure -menu .menubar
proc __StrOpen {} {
  after idle ::getOpenFileHelper
  set file [tk_getOpenFile -filetypes {{{Structure Files} {.str}}} -title "Read a Floops Structure File Or Parameter DB"]
  if { [string first ".str" $file] > -1 } {
      __StructureGUI $file
  } else {
      puts "unrecognized file"
  }
}

pack [button .1ddif -font {Helvetica 14 bold} -height 5 -width 20 -text "1D Diffusion" -command "1ddifWidget"] -side left
pack [button .2dstr -font {Helvetica 14 bold} -height 5 -width 20 -text "2D Structure Explore" -command "__StrOpen"] -side left
