proc SelDialog {} {
    global FLXSHOME
    MakeWindow .select Select $FLXSHOME/help/Post/select.html

    #for information purposes, display the current solution variables
    set list [format "Solution Variables: x y z %s" [sel list]]
    label .select.txtbox -width 80 -height 3 -text $list -anchor nw
    pack .select.txtbox -side top -expand 1 -fill x

    #create an entry box for the expression
    frame .select.fr -bd 2
    pack .select.fr -side top -expand 1 -fill x
    label .select.fr.lab -text "Expression: " -anchor w
    pack .select.fr.lab -side left -anchor w -fill x

    global locExpr
    entry .select.fr.ent -relief sunken -width 40 -textvariable locExpr
    pack .select.fr.ent -side left -anchor w -fill x

    tkwait window .select
    return $locExpr
}


proc AddCutDialog { w } {
    set dim [flps_grid qual dim]
    if { $dim >= 2 } {
	MakeEntrySwitch $w cutdur1 "x y" "Cut Line Constant"
	MakeEntryFloat $w "Cut Position" cutpos1 "Location of cut" 
    } 
    if {$dim == 3 } {
	MakeEntrySwitch $w cutdur2 "x y z" "Cut Line Constant"
	MakeEntryFloat $w "Cut Position" cutpos2 "Location of cut" 
    }
}


proc GetCutDialog {  } {
    set cmd " "
    set dim [flps_grid qual dim]
    if { $dim >= 2 } {
	if { $cutdir1 == "x" } {set cmd "$cmd x.val = $cutpos1"}
	if { $cutdir1 == "y" } {set cmd "$cmd y.val = $cutpos1"}
	if { $cutdir1 == "z" } {set cmd "$cmd z.val = $cutpos1"}
    } 
    if {$dim == 3} {
	if { $cutdir2 == "x" } {set cmd "$cmd x.val = $cutpos2"}
	if { $cutdir2 == "y" } {set cmd "$cmd y.val = $cutpos2"}
	if { $cutdir2 == "z" } {set cmd "$cmd z.val = $cutpos2"}
    }
    return $cmd
}

proc Plot1Dialog {} {
    global FLXSHOME
    MakeWindow .plot Select $FLXSHOME/help/Post/plot.1d.html

    #for information purposes, display the current solution variables
    global Select
    label .plot.txtbox -width 80 -height 3 -text "$Select" -anchor nw
    pack .plot.txtbox -side top -expand 1 -fill x

    AddCutDialog .plot

    MakeEntryBool .plot "Clear" clear "Clear Existing Data"
    #MakeEntryBool .plot "Boundary" bound "Plot Material Boundaries"
    tkwait window .plot

    global ParamRetcode
    if {$ParamRetcode} {
	global clear bound cutdir1 cutdir2 cutpos1 cutpos2
	set cmd "window; plot1d log"
	set cmd "$cmd [GetCutDialog]"
	if { $clear } {set cmd "$cmd clear"} else {set cmd "$cmd !clear"} 
	#if { $bound } {set cmd "$cmd bound"} else {set cmd "$cmd !bound"} 
	eval $cmd
    }
}
