proc DepDialog {} {
    global FLXSHOME
    MakeWindow .deposit Deposit $FLXSHOME/help/Post/deposit.html

    global thick layers mater
    set thick 0.1
    set layers 1
    set mater "Oxide"

    MakeEntryFloat .deposit "Thickness" thick "Thickness in um"
    MakeEntryInt .deposit "Grid Layers" layers "number of grid lines in deposited material"
    MakeEntrySwitch .deposit mater [mater all bulk] "Deposited Material"

    tkwait window .deposit

    global ParamRetcode
    if {$ParamRetcode} {
	#do some error checking
	if { $thick <= 0.0 } {return -code error "Must use positive thickness"}
	if { $layers < 1 } {return -code error "Must have more than one grid line"}

	#create a machine to do our bidding!
	machine name = tmpdep clear deposit
	machine name = tmpdep deposit $mater rate = [expr $thick / $layers] iso

	#loop over the command to get the layers inserted
	for {set i 0} {$i < $layers} {incr i} {
	    deposit mach = tmpdep time = 1
	}
    }
}


proc EtchDialog {} {
    global FLXSHOME
    MakeWindow .etch Etch $FLXSHOME/help/Post/etch.html

    global thick mater left right front back
    set thick 0.1
    set mater "Silicon"
    set left 1.0
    set right 2.0
    set front 1.0
    set back 2.0

    MakeEntryFloat .etch "Thickness" thick "Thickness in um"
    if { [flps_grid qual dim] > 1 } {
	MakeEntryFloat .etch "Left Edge" left "Left Edge of opening in um"
	MakeEntryFloat .etch "Right Edge" right "Right Edge of opening in um"
    } elseif { [flps_grid qual dim] > 2 } {
	MakeEntryFloat .etch "Front Edge" front "Front Edge of opening in um"
	MakeEntryFloat .etch "Back Edge" back "Back Edge of opening in um"
    }
    MakeEntrySwitch .etch mater [mater list bulk] "Material to Etch"

    puts "wait for window to close"
    tkwait window .etch

    global ParamRetcode
    if {! $ParamRetcode} return

    #do some error checking
    if { $thick <= 0.0 } {return -code error "Must use positive thickness"}

    if { [flps_grid qual dim] == 1 } {
	#create a machine to do our bidding!
	machine name = tmpetch clear etch
	machine name = tmpetch etch $mater rate = $thick iso
	etch mach = tmpetch time = 1
    } else { 
	mask clear name = tmpmask etch
	if { [flps_grid qual dim] == 2 } {
	    mask left = $left right = $right name = tmpmask
	} else {
	    mask left=$left right=$right front=$front back=$back name=tmpmask
	}
	machine name = tmpetch clear etch
	machine name = tmpetch etch $mater rate = $thick aniso
	etch mach = tmpetch time = 1 mask = tmpmask
    }
}
