proc PotentialEqns { Mat Sol } {
    set pdbMat [pdbName $Mat]
    set Vt (8.617383e-5*(Temp+273.0))

    set terms [solution list]
    if {[lsearch $terms Charge] == -1} {
	solution name = Charge add const val = 0.0 $Mat
    }

    set Poiss 0
    if {[pdbIsAvailable $pdbMat $Sol Poisson]} {
	if {[pdbGetBoolean $pdbMat $Sol Poisson]} {set Poiss 1}
    }

    set ni ([pdbDelayDouble $pdbMat $Sol ni])

    if {! $Poiss} {
	set neq "0.5*(Charge+sqrt(Charge*Charge+4*$ni*$ni))/$ni"

	solution name = Noni add const val = "exp( Potential / $Vt)" $Mat
	solution name = Poni add const val = "exp( - Potential / $Vt)" $Mat

	set eq "Potential / $Vt - log($neq)"
	pdbSetString $pdbMat $Sol Equation $eq
    } else {

	#set a solution variable
	set sols [solution list]
	if {[lsearch $sols Potential] == -1} {
	    solution add name = Potential solve damp negative
	}

	solution name = Noni add const val = "exp( Potential / $Vt)" $Mat
	solution name = Poni add const val = "exp( - Potential / $Vt)" $Mat

	set eps "([pdbDelayDouble $pdbMat $Sol Permittivity] * 8.854e-14 / 1.619e-19)"
	set eq "$eps * grad(Potential) + $ni * (Poni - Noni) + Charge"
	pdbSetString $pdbMat $Sol Equation $eq
    }
    puts "$pdbMat $Sol Equation: [pdbGetString $pdbMat $Sol Equation]"
}

proc PotentialInit { Mat Sol } {
    solution name = Charge add const val = 0.0 $Mat
}
