#/*************************************************************************
#*									 *
#*     Copyright c 1999 The board of regents of the University of 	 *
#*                      Florida.  All rights reserved.			 *
#*     This subroutine may not be used outside of the FLOO* computer	 *
#*     programs without the prior written consent of the University of 	 *
#*     Florida.								 *
#*									 *
#*************************************************************************/
#/*   plot.tcl                Version 1.10     */
#/*   Last Modification : 05/27/99 11:01:19  */

set ColorList {#0000ff #00ff00 #ff0000 #ff00ff #00ffff #000000 #ca0078 #ca7800 #78ca00 #0078ca #7800ca}

proc CreateGraphOldWindow {} {
    puts "inside create graph old window"
    global GraphWindow flxs_library
    #create the graph window and initialize it
    set foo [open "| $GraphWindow" w]
    puts $foo "set flxs_library $flxs_library"
    puts $foo "set flxs_library $flxs_library/Plot"
    puts $foo "source ${flxs_library}/Plot/Plot.tk"
    puts $foo "namespace import blt::*"
    flush $foo

    #create the global array information for the window
    set arr ${foo}Arr
    global $arr
    array set $arr "bound 0"
    array set $arr "colIndex 0"
    array set $arr "PenNames {}"
    return $foo
}

proc OldAddtoLine {Win Name X Y} {
    #check and see if the line exists currently
    set arr ${Win}Arr 
    global $arr
    set Hold [array get $arr PenNames]

    #returns true if name exists...
    if { [lsearch -exact [lindex $Hold 1] $Name] == -1 } {
	CreateSingleLine $Win $Name [list $X $Y]
    } else {
	set str [format {set xl [.graph element cget %s -xdata]} $Name]
	puts $Win $str
	puts $Win "lappend xl $X"
	set str [format {set yl [.graph element cget %s -ydata]} $Name]
	puts $Win $str
	puts $Win "lappend yl $Y"
	set str [format ".graph element configure %s -xdata $%s" $Name xl]
	puts $Win $str
	set str [format ".graph element configure %s -ydata $%s" $Name yl]
	puts $Win $str
    }
    flush $Win
}

proc CreateGraphNewWindow {} {
    puts "inside create graph window"
    return [chart backward]
}

proc AddtoLine {Win Name X Y} {
    chart chart = $Win curve = $Name xval = $X yval = $Y
}

proc SetAxisType {Win Axis log} {
    if {[string compare $log log]==0} {
	chart chart = $Win log
    }
}

proc CreateLine {Win Name Data} {
    global ColorList 
    set Name [CreatePen $Win $Name] 
    #puts $Win ".graph pen create $Name"
    #puts $Win ".graph pen configure $Name -symbol none"
    #puts $Win ".graph pen configure $Name -linewidth 2"

    set arr ${Win}Arr
    global $arr
    set ci [lindex [array get $arr colIndex] 1]
    puts $Win ".graph pen configure $Name -color [lindex $ColorList $ci]"
    set ci [expr ($ci + 1) % [llength $ColorList]]
    array set $arr "colIndex $ci"
    puts $Win ".graph element create $Name -data [list [lindex $Data 0]]"
    puts $Win ".graph element configure $Name -pen $Name"
    flush $Win
    for {set i 1} {$i < [llength $Data]} {incr i} {
	puts $Win ".graph element create ${Name}.$i"
	set foo ".graph element configure ${Name}.$i"
	puts $Win "$foo -data [list [lindex $Data $i]]"
	puts $Win "$foo -pen $Name"
	puts $Win "$foo -label {}"
	flush $Win
    }
}


proc CreatePen {Win Name} {
    set arr ${Win}Arr 
    global $arr
    set Hold [array get $arr PenNames]
    set OldNames [lindex $Hold 1] 
    set Locate [lsearch -exact $OldNames $Name]
    set index 0 
    set count 0
    set orig $Name  
    while { $Locate >= 0 } {
       set Name $orig 
       set Name ${Name}_${index}
       incr index 1
       set Locate [lsearch -exact $OldNames $Name]
    }
    lappend OldNames $Name
    array set $arr "PenNames [list $OldNames]"
    puts $Win ".graph pen create $Name"
    puts $Win ".graph pen configure $Name -symbol none"
    puts $Win ".graph pen configure $Name -linewidth 2" 
    return $Name
}

proc CreateSingleLine {Win Name Data} {
    global ColorList
    #puts $Win ".graph pen create $Name"
    #puts $Win ".graph pen configure $Name -linewidth 2"
    #puts $Win ".graph pen configure $Name -symbol none"
    set Name [CreatePen $Win $Name]
    set arr ${Win}Arr
    global $arr
    set ci [lindex [array get $arr colIndex] 1]
    puts $Win ".graph pen configure $Name -color [lindex $ColorList $ci]"
    set ci [expr ($ci + 1) % [llength $ColorList]]
    array set $arr "colIndex $ci"

    puts $Win ".graph element create $Name -data [list $Data]"
    puts $Win ".graph element configure $Name -pen $Name"
    flush $Win
}

proc ClearGraph {Win} {
    puts $Win {foreach line [.graph element name] {.graph element delete $line}}
    puts $Win {foreach line [.graph marker names] {.graph marker delete $line}}
    puts $Win {foreach line [.graph pen names] {
	if {! [string match "active*" $line] } {.graph pen delete $line}}}
    puts $Win ".graph axis configure x -min {}"
    puts $Win ".graph axis configure x -max {}"
    puts $Win ".graph axis configure y -min {}"
    puts $Win ".graph axis configure y -max {}"
    flush $Win

    set arr ${Win}Arr
    global $arr
    array set $arr "bound 0"
    array set $arr "colIndex 0"
    array set $arr "PenNames {}"
}


proc CreateBound {Win Name Data} {
    set arr ${Win}Arr
    global $arr

    set init [lindex [array get $arr bound] 1]
    set minx 1.0e30
    set miny 1.0e30
    set maxx -1.0e30
    set maxy -1.0e30
    #if first bounding box, create the element for the BoundBox
    if {! $init} {
	puts $Win ".graph pen create BoundBox"
	puts $Win ".graph pen configure BoundBox -symbol none"
	puts $Win ".graph pen configure BoundBox -linewidth 0"
	puts $Win ".graph element create BoundBox"
	puts $Win {.graph element configure BoundBox -pen BoundBox}
    } else {
	set minx [lindex [array get $arr minx] 1]
	set miny [lindex [array get $arr miny] 1]
	set maxx [lindex [array get $arr maxx] 1]
	set maxy [lindex [array get $arr maxy] 1]
    }

    for {set i 0} {$i < [llength $Data]} {incr i} {
	puts $Win ".graph marker create polygon -name $Name"
	set foo ".graph marker configure $Name"
	puts $Win "$foo -coords [list [lindex $Data $i]]"
	puts $Win "$foo -fill {}"
	puts $Win "$foo -outline #000000 "
	puts $Win "$foo -linewidth 1"

	set j 1
	foreach c [lindex $Data $i] {
	    if {$j%2} {
		if {$c < $minx} {set minx $c}
		if {$c > $maxx} {set maxx $c}
	    } else {
		if {$c < $miny} {set miny $c}
		if {$c > $maxy} {set maxy $c}
	    }
	    incr j
	}
    }

    #store away the values
    array set $arr "bound 1"
    array set $arr "minx $minx"
    array set $arr "miny $miny"
    array set $arr "maxx $maxx"
    array set $arr "maxy $maxy"
    set str [format {set rect [list %s %s %s %s %s %s %s %s %s %s]} $minx $miny $minx $maxy $maxx $maxy $maxx $miny $minx $miny]
    puts $Win $str
    puts $Win {.graph element configure BoundBox -data $rect}
    flush $Win
}

proc FlipY {Win Dir} {
    puts $Win ".graph axis configure y -descending $Dir"
    flush $Win
}

proc SetLimits {Win Axis Min Max} {
    puts $Win ".graph axis configure $Axis -min $Min"
    puts $Win ".graph axis configure $Axis -max $Max"
    flush $Win
}

