
proc getVector2D { name scal } {
	sel z= $scal*dot($name,x)
	set tmp [struct dump]
	set tmp [split $tmp "\n"]
	set vx ""
	foreach i $tmp {
		if {$i != {}} {
			lappend vx [lindex $i 2]
		}
	}

	sel z= $scal*dot($name,y)
	set tmp [struct dump]
	set tmp [split $tmp "\n"]

	set v ""
	set j 0
	foreach i $tmp {
		if {$i != {} } {
			if { $j == 0 } {
				set v "[expr 1*[lindex $i 0]] [expr 1*[lindex $i 1]] [lindex $vx $j] [lindex $i 2]"
			} else {
				set v "$v\n[expr 1*[lindex $i 0]] [expr 1*[lindex $i 1]] [lindex $vx $j] [lindex $i 2]"
			}
		}
		incr j
	}
	return $v
}
proc pyplotvars {} {
	uplevel [expr [info level]-1] {
		set PyPlotImports {
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import colorsys
import os
	}
	}
}

proc pyplot2D args {
	set tmp [struct dumpele]
	set filName "tmpbac[clock milliseconds]"
	set fil [open $filName "w"]
	puts $fil $tmp
	close $fil
	pyplotvars
	
	set importOrder "\['x1', 'y1', 'x2', 'y2', 'x3', 'y3', 'val'\]"
	set importOrder "\['y1', 'x1', 'y2', 'x2', 'y3', 'x3', 'val'\]"
	set importDat "bac = pd.read_csv('$filName', delimiter=' ', names=$importOrder)\nos.remove('$filName')"

	set points {[[bac['x1'][i],  bac['y1'][i]], [bac['x2'][i], bac['y2'][i]], [bac['x3'][i], bac['y3'][i]], [bac['x1'][i], bac['y1'][i]]]}
	set edgeColor {'black'}
	set edgeColor {color}

	set pycode "

plt.axes()

colors = np.linspace(0,1,num=1000)
min = (bac\['val'\].to_numpy()\[np.logical_not(np.isneginf(bac\['val'\].to_numpy()))\].min())
max = (bac\['val'\].to_numpy().max())
map = np.linspace(min,max,num=1000)
def find_nearest_index(array, value):
    array = np.asarray(array)
    idx = (np.abs(array - value)).argmin()
    return idx
for i in range(0, bac.shape\[0\]) :
	c = (float(colors\[find_nearest_index(map, bac\['val'\]\[i\])]))
	color = colorsys.hsv_to_rgb(c,1,0.9)
	points = $points
	polygon = plt.Polygon(points, ec=$edgeColor, fc=color)
	plt.gca().add_patch(polygon)

ratio = 1.0
xmin = (bac\['x1'\].min())
xmax = (bac\['x1'\].max())
ymin = (bac\['y1'\].min())
ymax = (bac\['y1'\].max())

plt.gca().set_xlim(left=xmin, right=xmax)
plt.gca().set_ylim(bottom=ymin, top=ymax)
plt.gca().set_aspect(abs((xmax-xmin)/(ymax-ymin))*ratio)

plt.gca().invert_yaxis()

"
	set output "plt.show()"
	set pycode "$PyPlotImports\n$importDat\n$pycode\n$output\n"
	puts [exec echo $pycode | python3 &]
}

proc pyplotVector2D { name scale background } {
	set vec [getVector2D $name $scale ]
	set fil [open "tmpvec" "w"]
	puts $fil $vec
	close $fil

	sel z= $background
	set tmp [struct dumpele]
	set fil [open "tmpbac" "w"]
	puts $fil $tmp
	close $fil

	pyplotvars

	set pycode {

plt.axes()

#bac = pd.read_csv('tmpbac', delimiter=' ', names=['x1', 'y1', 'x2', 'y2', 'x3', 'y3', 'val'])
bac = pd.read_csv('tmpbac', delimiter=' ', names=['y1', 'x1', 'y2', 'x2', 'y3', 'x3', 'val'])


colors = np.linspace(0,1,num=1000)
min = (bac['val'].to_numpy()[np.logical_not(np.isneginf(bac['val'].to_numpy()))].min())
max = (bac['val'].to_numpy().max())
map = np.linspace(min,max,num=1000)
def find_nearest_index(array, value):
    array = np.asarray(array)
    idx = (np.abs(array - value)).argmin()
    return idx
for i in range(0, bac.shape[0]) :
	c = (float(colors[find_nearest_index(map, bac['val'][i])]))
	color = colorsys.hsv_to_rgb(c,1,0.9)
	#points = [[100*bac['x1'][i],  bac['y1'][i]], [100*bac['x2'][i], bac['y2'][i]], [100*bac['x3'][i], bac['y3'][i]], [100*bac['x1'][i], bac['y1'][i]]]
	points = [[bac['x1'][i],  bac['y1'][i]], [bac['x2'][i], bac['y2'][i]], [bac['x3'][i], bac['y3'][i]], [bac['x1'][i], bac['y1'][i]]]
	#polygon = plt.Polygon(points, ec=(0,0,0), fc=color)
	polygon = plt.Polygon(points, ec=color, fc=color)
	plt.gca().add_patch(polygon)

#data = pd.read_csv('tmpvec', delimiter=' ', names=['x', 'y', 'vx', 'vy'])
data = pd.read_csv('tmpvec', delimiter=' ', names=['y', 'x', 'vy', 'vx'])
#plt.quiver(100*data['x'], data['y'], data['vx']/100, data['vy'], zorder=10, minlength=0.5)
plt.quiver(data['x'], data['y'], data['vx'], -data['vy'], zorder=10, minlength=0.5)

#plt.gca().set_aspect('equal', adjustable='box')
#plt.gca().invert_xaxis()
plt.gca().invert_yaxis()
ratio = 1.0
x_left, x_right = plt.gca().get_xlim()
y_low, y_high = plt.gca().get_ylim()
plt.gca().set_aspect(abs((x_right-x_left)/(y_low-y_high))*ratio)
#plt.axis('scaled')
os.remove("tmpvec")
os.remove("tmpbac")
plt.show()

}
	set pycode "$PyPlotImports $pycode"
	puts [exec echo $pycode | python3 &]
}

