#look at a dataset
#set fil [open "| h5dump -d /collection/geometry_0/state_0/dataset_0 n9_fps.tdr" r ]

#this command pulls the data name from dataset_0
#h5dump -p -a /collection/geometry_0/state_0/dataset_0/name n9_fps.tdr 

#without indices
#h5dump -w 0 -d "/collection/geometry_0/region_0/elements_0" n9_fps.tdr


#dump the file structure
#gives me a bunch of directory style data sets and groups.
#h5dump -n n9_fps.tdr

#dump the while vertex structure
#this gives me an enormous file with all the geometry info - the whole kit and kaboodle
#currently in file foo
#h5dump -g /collection/geometry_0 n9_fps.tdr

#this provides the stupid nested dataset of the number of regions
#h5dump -a "/collection/geometry_0/number of regions" n9_fps.tdr


#extract the value of an attribute
proc TDR_AttributeValue {nam att} {
    set arg "/collection/geometry_0/$att"
    set fil [open "| h5dump -w 0 -a \"$arg\" $nam" r]
    set d0 [read $fil]
    close $fil

    set d1 [lindex $d0 2]
    set d2 [lindex $d1 2]
    set d3 [lindex $d2 [expr [lsearch -exact $d2 DATA]+1]]
    return [lindex $d3 1]
}

proc TDR_ExtractVertexList {nam} {
    global VertexList
    set fil [open "| h5dump -m %.24f -d /collection/geometry_0/vertex $nam" r]
    set d0 [read $fil]
    close $fil

    set d1 [lindex $d0 2]
    set d2 [lindex $d1 2]
    regsub -all {\([0-9]*\):} [lindex $d2 7] " " d3
    regsub -all {,} $d3 " " VertexList
    return $VertexList
}

proc TDR_ExtractVertex {i} {
    global VertexList
    return [lindex $VertexList $i]
}

proc TDR_ElementList {nam reg} {
    global ElementList
    set fil [open "| h5dump -w 0 -d /collection/geometry_0/region_$reg/elements_0 $nam" r]
    set d0 [read $fil]
    close $fil
    set d1 [lindex $d0 2]
    set d2 [lindex $d1 2]
    set d3 [lindex $d2 [expr [lsearch -exact $d2 DATA]+1]]
    regsub -all {\([0-9]*\):} $d3 " " d4
    regsub -all "," $d4 " " ElementList
}

#get the ith element and jth node
proc TDR_ElementExtract {dim i j} {
    global ElementList
    set enum [expr ($dim+2) * $i]
    if { [lindex $ElementList $enum] != $dim } {
	return -code error "The dimensions are not consistent"
    }

    return [lindex $ElementList [expr $enum + $j]]
}


proc TDR_ValueList { nam i } {
    global ValueList
    set fil [open "| h5dump -w 0 -d /collection/geometry_0/state_0/dataset_$i/values $nam" r]
    set d0 [read $fil]
    close $fil
    set d1 [lindex $d0 2]
    set d2 [lindex $d1 2]
    set d3 [lindex $d2 [expr [lsearch -exact $d2 DATA]+1]]
    regsub -all "," $d3 " " d4
    regsub -all {\(} $d4 " " d5
    regsub -all {\):} $d5 " " d6
    set ValueList [lrange $d6 1 end]
}

proc TDR_ValueExtract { i } {
    global ValueList
    return [lindex $ValueList $i]
}
